#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: vserver_activate.pl Fri 28 Oct 2011 06:57:03 AM CEST
# Copyright 2011 Stauber Multimedia Design. All rights reserved.
#
# Enables and starts (or stops and disables) monitoring of Vserver Status

use CCE;

my $cce = new CCE;
$cce->connectfd();

my $oid = $cce->event_oid();
my $obj = $cce->event_object();

my @oids = $cce->find('System');
if (@oids) {
    my ($ok, $obj) = $cce->get($oids[0], 'VserverStatus');
    my $enabled = $obj->{enabled};

    # We tell ActiveMonitor if it should  monitor this component:
    @amOIDS = $cce->find('ActiveMonitor');
    if (@amOIDS) {
        $cce->set($amOIDS[0], 'VSERVER', {
        'enabled' => $enabled
        });
    }
}
else {
  # we have major problems if the System object doesn't exist,
  # some code to crash out with an error and create panic
  print STDERR "No System object in CCE!!!!\n";
  exit 0;
}

$cce->bye('SUCCESS');
exit(0);

