#!/usr/bin/perl
# $Id: crond_checker.pl,v 2.0.0 Fri 28 Oct 2011 06:25:33 AM CEST mstauber Exp $
# Copyright 2007-2011 Stauber Multimedia Design. All rights reserved.
#
# Description:
#
# Script that runs through a cronjob, tests if all running VPS's have a file called
# /etc/init.d/crond. If they do, it's checked if Crond is running in that VPS. If not,
# then Crond is restarted.
#

if (( -d "/vz/private") && ( -f "/proc/vz/veinfo")) {
        system("/bin/rm -f /tmp/cronve-stats");
        system("/usr/sbin/vzlist -a --no-header | grep -v stopped | grep -v mounted | wc -l > /tmp/cronve-stats");
        open(F, "/tmp/cronve-stats");
        while ($line = <F>) {
                chomp($line);
                next if $line =~ /^\s*$/;               # skip blank lines
                if ($line =~ /^0/) {
                        $running_vps_present = "0";
                }
                else {
                        $running_vps_present = "1";
                }
        }
        close (F);
        system("/bin/rm -f /tmp/cronve-stats");
}

if (( -d "/vz/private") && ($running_vps_present eq "1") && ( -f "/proc/vz/veinfo")) {
    system("/usr/sbin/vzlist --no-header --output veid |  awk '{print \$1}' > /tmp/cronve-list");
    open(G, "/tmp/cronve-list");
    while ($line = <G>) {
        chomp($line);
        next if $line =~ /^\s*$/;               # skip blank lines
        if ($line =~ /^([0-9]\w*)/) {
            $VPS_ID = $line;
        }

        if ($VPS_ID != 0) {
            if ( -f "/vz/private/$VPS_ID/etc/init.d/crond" ) {
                $report = system("/usr/sbin/vzctl exec $VPS_ID /etc/init.d/crond status > /dev/null");

                if ($report != "0") {
                    system("/usr/sbin/vzctl exec $VPS_ID /etc/init.d/crond restart > /dev/null");
                }
            }
        }
    }
    close (G);
    system("/bin/rm -f /tmp/cronve-list");
}

